#include <stdio.h>
#include <omp.h>

#ifndef N
#define N 1024
#endif

#define TIMES 8

float a[N][N];

int main(void)
{
	unsigned int i = 0, j = 0, t = 0;
	double start = 0.0;

	start = omp_get_wtime();
	#pragma omp parallel private(i,j,t) shared(start,a)
	for (t=0; t<TIMES; ++t) {
		#pragma omp for
		for (i=1; i<N-1; ++i)
		for (j=1; j<N-1; ++j)
			a[i][j] = (a[i-1][j]+a[i+1][j]+a[i][j-1]+a[i][j+1])/4.0f;
	}
	printf("%f", ((long)TIMES*N*N*4*sizeof(float))/((1<<30)*(omp_get_wtime()-start)));

	return 0;
}
